' SaveHTML.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-06-13
' SaveHTML.VBS saves HTML file from URL.
' Usage: SaveHTML.VBS URL [htmlfilename]

Option Explicit
Const cdoSuppressAll=31
Const adSaveCreateNotExist=1
Const adSaveCreateOverWrite=2 
Const adReadAll=-1
Const adWriteChar=0
Const adWriteLine=1
Dim URL
Dim Path
Dim fso
Dim CDOMessage
Dim Stream
Dim Text
Dim re
Dim Matches

If WScript.Arguments.Count=0 Then
  URL=InputBox("Enter URL",WScript.ScriptName)
Else
  URL=WScript.Arguments.Item(0)
End If
If URL="" Or WScript.Arguments.Count>2 Then
  WScript.Echo "Usage: SaveHTML.VBS URL [htmlfilename]"
  WScript.Quit
End If
If WScript.Arguments.Count=2 Then
  Path=WScript.Arguments.Item(1)
Else
  Path=Replace(Replace(Replace(Replace(URL,":","_"),"/","_"),"\","_"),"?","_")
  Path=Left(Replace(Path,"%20"," "),125)&".htm"
  Path=FileSaveAs(Path)
  If Path="" Then WScript.Quit
End If
Set fso=CreateObject("Scripting.FileSystemObject")
If fso.FileExists(URL) Then 
  URL="file://"&fso.GetAbsolutePathName(URL)
End If

Set CDOMessage=CreateObject("CDO.Message") 
CDOMessage.AutoGenerateTextBody=False
'Sub CreateMHTMLBody(URL As String, [Flags As CdoMHTMLFlags = cdoSuppressNone], [UserName As String], [Password As String])
'    Creates an MHTML-formatted message body using the contents at the specified URL
CDOMessage.CreateMHTMLBody URL,cdoSuppressAll
Set Stream=CDOMessage.BodyPart.GetDecodedContentStream()
'MsgBox CDOMessage.BodyPart.Charset
'MsgBox Stream.Charset
Select Case LCase(Stream.Charset)
Case "iso-8859-1"
  Text=Stream.ReadText(adReadAll)
  Stream.Position=0
  Set re=New RegExp
  re.IgnoreCase=True
  re.Pattern="\bcharset\s*=\s*([-A-Za-z0-9_]+)"
  Set Matches=re.Execute(Text)
  If Matches.Count Then
    Stream.Charset=Matches(0).SubMatches(0)
  End If
End Select
'MsgBox Stream.Charset
Select Case LCase(Stream.Charset)
Case "shift_jis","x-sjis","iso-8859-1"
  Stream.SaveToFile Path,adSaveCreateOverWrite 
Case Else
  Text=Stream.ReadText(adReadAll)
  Stream.Position=0
  Stream.Charset="shift_jis"
  Stream.WriteText "<HTML><HEAD><META http-equiv=Content-Type content=""text/html; charset=shift_jis""></HEAD></HTML>",adWriteLine
  Stream.WriteText Lint(Text),adWriteChar
  Stream.SetEOS
  Stream.SaveToFile Path,adSaveCreateOverWrite 
End Select
WScript.Quit

Function FileSaveAs(Path)
Dim FileSaveDlg
On Error Resume Next
Set FileSaveDlg=CreateObject("SAFRCFileDlg.FileSave") 
On Error GoTo 0
If IsEmpty(FileSaveDlg) Then
  FileSaveAs=Path
  Exit Function
End If
FileSaveDlg.FileName=Path
FileSaveDlg.FileType="ׂẴt@C(*.*)" 
If FileSaveDlg.OpenFileSaveDlg() Then FileSaveAs=FileSaveDlg.FileName 
End Function

Function Lint(Text)
Dim k
Dim char
Dim chars
ReDim chars(Len(Text)-1)

For k=1 To Len(Text)
  char=Mid(Text,k,1)
  If Chr(Asc(char))=char Then
    chars(k-1)=char
  Else
    Select Case AscW(char)
    Case &HA0 chars(k-1)="&nbsp;"
    Case &HA9 chars(k-1)="&copy;"
    Case &HAE chars(k-1)="&reg;"
    Case Else chars(k-1)="&#"&AscW(char)&";"
    End Select
  End If
Next
Lint=Join(chars,Empty)
End Function
